use std::ops::{Index, IndexMut};

use pacman::Vec2;

const TT: bool = true;
#[allow(non_upper_case_globals)]
const o: bool = false;

pub const BOARD_WIDTH: usize = 28;
pub const BOARD_HEIGHT: usize = 31;

pub struct Board(pub [[bool; BOARD_WIDTH]; BOARD_HEIGHT]);

impl Index<Vec2> for Board {
    type Output = bool;

    fn index(&self, index: Vec2) -> &Self::Output {
        &self.0
        [index.y.rem_euclid(BOARD_HEIGHT as i32) as usize]
        [index.x.rem_euclid(BOARD_WIDTH as i32) as usize]
    }
}

impl IndexMut<Vec2> for Board {
    fn index_mut(&mut self, index: Vec2) -> &mut Self::Output {
        &mut self.0
        [index.y.rem_euclid(BOARD_HEIGHT as i32) as usize]
        [index.x.rem_euclid(BOARD_WIDTH as i32) as usize]
    }
}

pub const BOARD: Board = Board([
    [TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT],
    [TT, o, o, o, o, o, o, o, o, o, o, o, o,TT,TT, o, o, o, o, o, o, o, o, o, o, o, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o, o, o, o, o, o,TT,TT, o, o, o, o,TT,TT, o, o, o, o,TT,TT, o, o, o, o, o, o,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o, o, o, o, o, o, o, o, o, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [ o, o, o, o, o, o, o, o, o, o,TT,TT,TT,TT,TT,TT,TT,TT, o, o, o, o, o, o, o, o, o, o],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o, o, o, o, o, o, o, o, o, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT],
    [TT, o, o, o, o, o, o, o, o, o, o, o, o,TT,TT, o, o, o, o, o, o, o, o, o, o, o, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o,TT,TT,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT, o,TT,TT,TT,TT, o,TT],
    [TT, o, o, o,TT,TT, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o,TT,TT, o, o, o,TT],
    [TT,TT,TT, o,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT, o,TT,TT,TT],
    [TT,TT,TT, o,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT, o,TT,TT,TT],
    [TT, o, o, o, o, o, o,TT,TT, o, o, o, o,TT,TT, o, o, o, o,TT,TT, o, o, o, o, o, o,TT],
    [TT, o,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT, o,TT],
    [TT, o,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT, o,TT,TT, o,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT, o,TT],
    [TT, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o, o,TT],
    [TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT,TT],
]);